<?php

namespace cn\com\maiyoule\mqttclient\biz;

use cn\com\maiyoule\mqttclient\IRequest;

class AppUserCreateRequest extends IRequest
{

    public function path(): string
    {
        return 'mqtt/user/create';
    }

    public function body(): array
    {
        return [
            'password' => $this->getPassword(),
            'fettle' => $this->getFettle(),
            'role' => $this->getRole(),
            'publish' => join(',', $this->getPublish()),
            'subscribe' => join(',', $this->getSubscribe()),
            'expire' => $this->expireAt
        ];
    }

    private array $subscribe = [];

    public function getSubscribe(): array
    {
        return $this->subscribe;
    }

    public function setSubscribe(array|string $subscribe): void
    {
        if (is_string($subscribe)) {
            $subscribe = [$subscribe];
        }
        $this->subscribe = $subscribe;
    }

    /**
     * @var string 过期时间
     */
    private string $expireAt = '';

    public function getExpireAt(): string
    {
        return $this->expireAt;
    }

    public function setExpireAt(string $expireAt): void
    {
        $this->expireAt = $expireAt;
    }


    private array $publish = [];

    public function getPublish(): array
    {
        return $this->publish;
    }

    public function setPublish(array|string $publish): void
    {
        if (is_string($publish)) {
            $publish = [$publish];
        }

        $this->publish = $publish;
    }


    private string $password = '';
    private string $fettle = '';
    private string $role = 'user';


    public function getRole(): string
    {
        return $this->role;
    }

    public function setRole(string $role): void
    {
        $this->role = $role;
    }


    public function getPassword(): string
    {
        return $this->password;
    }

    public function setPassword(string $password): void
    {
        $this->password = $password;
    }

    public function getFettle(): string
    {
        return $this->fettle;
    }

    public function setFettle(string $fettle): void
    {
        $this->fettle = $fettle;
    }


}