<?php

namespace cn\com\maiyoule\mqttclient\biz\client;

class SendMQTTMessage
{
    /**
     * @var string 业务标识符
     */
    private string $biz;
    /**
     * @var string 目标客户端ID
     */
    private string $targetId;

    private string $message;

    private int $qoS = 0;

    private bool $retain = false;

    private function __construct()
    {
    }

    public static function create(string $biz, string $targetId, string $message, int $qos = 0, bool $retain = false): SendMQTTMessage
    {
        $instance = new self();
        $instance->setBiz($biz);
        $instance->setTargetId($targetId);
        $instance->setMessage($message);
        $instance->setQoS($qos);
        $instance->setRetain($retain);
        return $instance;
    }

    const QOS_0 = 0;
    const QOS_1 = 1;
    const QOS_2 = 2;

    public function isRetain(): bool
    {
        return $this->retain;
    }

    public function setRetain(bool $retain): void
    {
        $this->retain = $retain;
    }

    public function getQoS(): int
    {
        return $this->qoS;
    }

    public function setQoS(int $qoS): void
    {
        $this->qoS = $qoS;
    }

    public function getMessage(): string
    {
        return $this->message;
    }

    public function setMessage(string $message): void
    {
        $this->message = $message;
    }

    public function getTargetId(): string
    {
        return $this->targetId;
    }

    public function setTargetId(string $targetId): void
    {
        $this->targetId = $targetId;
    }

    public function getBiz(): string
    {
        return $this->biz;
    }

    public function setBiz(string $biz): void
    {
        $this->biz = $biz;
    }

}